/**
 * Implementao: constri rvores-exemplos e passeios in-ordem, recursivo e com rv. costurada
 * @author Lenidas O. Brando
 */

public class arvore {
  
   private no_bin raiz;

   public arvore(int i) {
     if (i==1) raiz = arvore1();
     else
     if (i==2) raiz = arvore2();
     else raiz = null;
     }
   
   public no_bin raiz() {
     return raiz;
     }

   // constroi rvore 1
   //                   0
   //                 /   \
   //                1     2
   //               /       \
   //              3         4
   //             / \       /
   //            5   6     7
   // 
   private no_bin arvore1() {
     no_bin no0, no1, no2, no3, no4, no5, no6, no7; //
     Integer [] info = new Integer[8]; //
     for (int i=0; i<8; i++) 
	 info[i]= new Integer(i);
     no5=new no_bin(info[5]); no6=new no_bin(info[6]); no7=new no_bin(info[7]);
     no3=new no_bin(no5,info[3],no6);  no4=new no_bin(no7,info[4],null);
     no1=new no_bin(no3,info[1],null); no2=new no_bin(null,info[2],no4);
     no0=new no_bin(no1,info[0],no2);
     return no0; // retorne a raz
     }


   // constroi rvore 1
   //                   0
   //                 / ^ \
   //                1-+   2
   //               / ^     \
   //              3  |      4-||
   //             /^\ |     /^
   //            5+  6+    7-+
   //                        
   // 
   private no_bin arvore2() {
     no_bin no0, no1, no2, no3, no4, no5, no6, no7; //
     Integer [] info = new Integer[8]; //
     for (int i=0; i<8; i++) 
	 info[i]= new Integer(i);
     no5=new no_bin(info[5]); no6=new no_bin(info[6]); no7=new no_bin(info[7]);
     no3=new no_bin(no5,info[3],no6);  no4=new no_bin(no7,info[4],null);
     no1=new no_bin(no3,info[1],null); no2=new no_bin(null,info[2],no4);
     no0=new no_bin(no1,info[0],no2);
     // costuras
     no1.costura(no0);
     no5.costura(no3); no6.costura(no1);
     no7.costura(no4); //no4.costura(null); no coloco custura no ltimo n p/ evitar teste (*)

     return no0; // retorne a raz
     }

  public void in_ordem(no_bin raiz, int nivel) {
    if ( raiz.esq != null ) in_ordem(raiz.esq, nivel+1);
    for (int i=0; i<nivel; i++) System.out.print("  ");
    System.out.println( raiz.info() );
    if ( raiz.dir != null ) in_ordem(raiz.dir, nivel+1);
    }

  // na costura estou supondo que cada subida por uma costura => nivel - 1 o que no  verdade sempre!!
  private void lista(no_bin no, int nivel) {
    for (int i=0; i<nivel; i++) System.out.print("  ");
    System.out.println( no.info() );
    }

  public void in_ordem_c(no_bin raiz) { //, int nivel) {
    no_bin no = raiz;
    int nivel = 0;
    while ( no != null ) {
      while ( no.esq != null ) {
        no = no.esq;
        nivel++;
        }
      lista(no,nivel);
      // percorre lista de costura at encontrar n com filho direito "legtimo"
      while ( no.costurado() ) {
              // && no.dir!=null ) { // (*) o teste de null  para tratar ltimo n
        no = no.dir;
        nivel--;
        lista(no,nivel);
        }
      no = no.dir;
      nivel++;
      }
  }
   
}

// um n da rvore
 class no_bin {
    no_bin esq;
    Object info;
    boolean costura;
    no_bin dir;

    int info() {
      return ((Integer)info).intValue();
    }

    boolean costurado() {
      return costura;
      }

    void costura(no_bin pai) {
      this.dir = pai; // pai na sequencia in-ordem
      this.costura = true;
      }

    no_bin() {
        costura = false;
	esq = null;
	info = null;
	dir = null;
    }

    no_bin(Object o) {
        costura = false;
	esq = null;
	info = o;
	dir = null;
    }

    no_bin(no_bin esq, Object o, no_bin dir) {
        costura = false;
	this.esq = esq;
	info = o;
	this.dir = dir;
    }
}
